Unit ML03R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU01_p, UTMN12_p, MLU28_p, MLU30_p, MLU29_p, MLU17_p, 
MLU32_p, MLU33_p, MLU18_p, MLU07_p, MLU34_p;

procedure ML03R(var A :Array of Real; DA :Integer;
                var U :Array of Real; M :Integer;
                var T :Array of Real; N :Integer;
                var SUM :Array of Real; var NS :Array of Integer;
                var NT :Array of Integer; var NSUM :Array of Integer;
                var X :Array of Real; var NX :Array of Integer;
                var P :Integer; EPS :Real; var XK :Array of Real;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);

implementation

procedure ML03R(var A :Array of Real; DA :Integer;
                var U :Array of Real; M :Integer;
                var T :Array of Real; N :Integer;
                var SUM :Array of Real; var NS :Array of Integer;
                var NT :Array of Integer; var NSUM :Array of Integer;
                var X :Array of Real; var NX :Array of Integer;
                var P :Integer; EPS :Real; var XK :Array of Real;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);
var
I,K,NI,NE,M1,I1,L,NA,J :Integer;
MIN,TET,TETA :Real;
const
O10T10 :Real = 10.0E10;
label
_1,_2,_14,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_100,_200,_300,_13;
begin
{        PEAETC AAA HEHOO }
{        POPAMMPOBAH MOPOBAHHM }
{        CMEKC-METOOM. }
{        HEKOTOPE ( BCE) EPEMEHHE }
{        MET BEP7HE OPAHEH. }
{        KOMOHEHT BEPXHX OPAHEH }
{        XPAHTC B MACCBE ALFA(KV). }
{        KV-KOECTBO OPAHEHHX }
{        CBEPXY E7EMEHHX.HOMEPA }
{        COOTBETCTBYX KOMOHEHT }
{           NALFA. }
{        A(DA)-OHOMEPH MACCB ,B }
{        KOTOPOM XPAHTC HEHYEBE }
{        EMEHT MATP YCOB(O CTOAM). }
{        HOMEP CTPOK    NS. }
{         U(M,M)-PAO MACCB  }
{        MATP, OPATHO K ACHO. }
{        M-KOECTBO OPAHEH C 2. }
{        T(N)-BEKTOP KOEHTOB HEHO }
{        OPM. B  NT  }
{        OECTBA HEHYEBX }
{        EMEHTOB MATP YCOB O CTOAM. }
{        N-KOECTBO EPEMEHHX. }
{        SUM(N)-MHYC CYMM EMEHTOB MATP }
{        YCOB O CTOAM.  NSUM }
{          . }
{          NSUM  [N/32+1]. }
{        X(M)-HA BXOE:BEKTOP PABX ACTE, }
{        PEM X(M-1)=0, X(M) PABHA MHYC }
{        CYMME PEYX KOMOHEHT;HA }
{        BXOE:BEKTOP-PEEHE,PEM }
{        X(M)-HEBKA,X(M-1)-HAEHE HEHO }
{        OPM,OCTAHE KOMOHEHT-HAEH }
{        ACHX EPEMEHHX,HOMEPA ACHX }
{        EPEMEHHX    NX. }
{        P-PHAK;HA BXOE:P=1,EC AAA }
{        OCTABEHA HA MAKCMYM,P HE PABHO 1,EC AAA }
{        OCTABEHA HA MHMYM;HA BXOE: }
{        P=1,EC AAA PEEHA, }
{        P=2,EC AAA POTBOPEBA, }
{        P=3,EC PEEHE HEOPAHEHO. }
{        EPS-MAA BEHA,COYEMA B }
{        OEPATOPAX CPABHEH BMECTO HY }
{        XK(M)-PAO BEKTOP. }
if ( P <> 1 )
 then goto _2;
for I:=1 to N do
 begin
  T[I-1] := -T[I-1];
_1:
 end;
_2:
MLU01(U,M);
for J:=1 to N do
 begin
_14:
  UTMN12(J,NSUM);
 end;
for I:=1 to M do
 begin
  K := N+I;
_3:
  NX[I-1] := K;
 end;
NI := 0;
NE := 1;
_4:
MLU28(MIN,U,M,A,DA,NS,N,NT,NSUM,SUM,T,K,
      ALFA,KV,NALFA);
goto _7;
_5:
MLU30(MIN,U,M,A,DA,N,NS,NT,NSUM,SUM,T,K,
      ALFA,KV,NALFA);
goto _7;
_6:
MLU29(MIN,U,M,A,DA,N,NS,NT,NSUM,SUM,T,K,
      ALFA,KV,NALFA,EPS);
_7:
if ( MIN < (-EPS) )
 then goto _10;
case NE of
 1: goto _8;
 2: goto _100;
 3: goto _100;
end;
_8:
NE := 2;
M1 := M-2;
for I:=1 to M1 do
 begin
  I1 := NX[I-1];
  if ( I1 > N )
   then NE := 3;
_9:
 end;
if ( NE = 3 ) and ( X[M-1] < (-EPS) )
 then goto _200;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_10:
MLU17(U,M,A,DA,NS,T,N,NT,SUM,K,XK);
MLU32(X,M,XK,K,L,TETA,NX,EPS,
        ALFA,KV,NA,NALFA);
if ( TETA = O10T10 )
 then goto _300;
MLU33(TETA,L,K,XK,M,ALFA,KV,NA,
NALFA,NX);
_11:
MLU18(X,XK,M,K,L,TETA,ALFA,KV,NA);
if ( L = 0 )
 then goto _12;
MLU07(U,M,XK,L);
MLU34(NX,M,K,L,SUM,N,NSUM);
_12:
NI := NI+1;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_100:
if ( P <> 1 )
 then X[M-2] := -X[M-2];
P := 1;
goto _13;
_200:
P := 2;
goto _13;
_300:
P := 3;
_13:
end;

end.
