Unit MLU30_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN13_p, MLU12_p;

procedure MLU30(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer; N :Integer;
                var NS :Array of Integer; var NT :Array of Integer;
                var NSUM :Array of Integer; var SUM :Array of Real;
                var T :Array of Real; var K :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);

implementation

procedure MLU30(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer; N :Integer;
                var NS :Array of Integer; var NT :Array of Integer;
                var NSUM :Array of Integer; var SUM :Array of Real;
                var T :Array of Real; var K :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer);
var
L,K1,K2,K3,KT,NJ,J,KT1 :Integer;
DEL :Real;
const
O16000 :Integer = 16000;
label
_2,_4,_3,_5,_1;
begin
{        POPAMMA AHAOHA SOL028.CO- }
{        YETC HA BTOPOM TAE. }
K3 := 0;
K1 := 1;
NJ := 1;
MIN := 0.0;
for J:=1 to N do
 begin
  KT := NT[J-1];
  if ( KT = 0 ) 
   then goto _1;
  UTMN13(J,NSUM,KT1);
  if ( KT1 = 1 )
   then goto _5;
_2:
  if ( K1 > KV )
   then goto _4;
  K2 := NALFA[K1-1];
  K3 := K2;
  if ( K2 > O16000 )
   then K3 := K2-O16000;
  if ( J <= K3 )
   then goto _4;
  K1 := K1+1;
  goto _2;
_4:
  MLU12(U,M,A,DA,NS,NJ,J,KT,T,SUM,N,DEL);
  if ( J <> K3 )
   then goto _3;
  if ( K2 > O16000 )
   then DEL := -DEL;
_3:
  if ( DEL >= MIN )
   then goto _1;
  MIN := DEL;
  K := J;
  goto _1;
_5:
  NJ := NJ+KT;
_1:
 end;
end;

end.
